; Source created with Parsic Version 3.x

; at              : 16/08/02 19.00.28


; Project File    : c:\PROGRA~1\PARSIC\COCOTEL.PIC

; Project Version : 1.0.22

; Created         : 14/05/02 20.38.00

; Last change     : 16/08/02 19.00.17

	PROCESSOR 16CE623

	INCLUDE P16CE623.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_ON & _PWRTE_ON & _WDT_ON & _BODEN_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

ZR1	= 32	; located in Bank 0
ZR1_FD	= 33	; located in Bank 0
TR1	= 34	; located in Bank 0
TR1_HI	= 35	; located in Bank 0
S0	= 36	; located in Bank 0
Z1	= 37	; located in Bank 0
OS1_FD	= 38	; located in Bank 0
OS2_FD	= 39	; located in Bank 0
S1	= 40	; located in Bank 0
OS3_FD	= 41	; located in Bank 0
RAM	= 42	; located in Bank 0
SYS_WSAV	= 112	; located in Bank 0, 1
SYS_SSAV	= 113	; located in Bank 0, 1
SYS_TMP1	= 114	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111101'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

	BCF STATUS,RP0	; Bank 0
	MOVLW 7	; Comparators off
	MOVWF CMCON
; init vars


; Clear RAM

	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1


	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Zhler -> ZR1
;***************************************************

	BTFSS S1,0	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S0,1
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

LABEL_ZR1_SETFD

	BTFSS S0,1
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 1	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 232
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 1	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 232
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,0
	GOTO LABEL_TR1_CLR
	BSF S0,0
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,0
LABEL_TR1_ENDE

;***************************************************
; Unterprogramm TAB aufrufen
;***************************************************

	MOVFW ZR1

	CALL TAB

	MOVWF Z1

	BSF INTCON,GIE
;***************************************************
; Verteiler -> BV1
;***************************************************

	BTFSC Z1,0
	GOTO LABEL_BV1_0
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0
	GOTO LABEL_BV1_0_END
LABEL_BV1_0
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,0
LABEL_BV1_0_END

;**********************************************

	BTFSC Z1,1
	GOTO LABEL_BV1_1
	BCF PORTB,1
	GOTO LABEL_BV1_1_END
LABEL_BV1_1
	BSF PORTB,1
LABEL_BV1_1_END

;**********************************************

	BTFSC Z1,2
	GOTO LABEL_BV1_2
	BCF PORTB,2
	GOTO LABEL_BV1_2_END
LABEL_BV1_2
	BSF PORTB,2
LABEL_BV1_2_END

;**********************************************

	BTFSC Z1,3
	GOTO LABEL_BV1_3
	BCF PORTB,3
	GOTO LABEL_BV1_3_END
LABEL_BV1_3
	BSF PORTB,3
LABEL_BV1_3_END

;**********************************************

	BTFSC Z1,4
	GOTO LABEL_BV1_4
	BCF PORTB,4
	GOTO LABEL_BV1_4_END
LABEL_BV1_4
	BSF PORTB,4
LABEL_BV1_4_END

;**********************************************

	BTFSC Z1,5
	GOTO LABEL_BV1_5
	BCF PORTB,5
	GOTO LABEL_BV1_5_END
LABEL_BV1_5
	BSF PORTB,5
LABEL_BV1_5_END

;**********************************************

	BTFSC Z1,6
	GOTO LABEL_BV1_6
	BCF PORTB,6
	GOTO LABEL_BV1_6_END
LABEL_BV1_6
	BSF PORTB,6
LABEL_BV1_6_END

;**********************************************

	BTFSC Z1,7
	GOTO LABEL_BV1_7
	BCF PORTB,7
	GOTO LABEL_BV1_7_END
LABEL_BV1_7
	BSF PORTB,7
LABEL_BV1_7_END

;**********************************************


;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS S0,0
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSC S0,3
	GOTO LABEL_LG1_FALSE
LABEL_LG1_3
	BTFSS PORTA,0
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S0,1
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF S0,1
LABEL_LG1_ENDE
;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S0,2
	GOTO LABEL_RS1_RESET
	BTFSS S0,5
	GOTO LABEL_RS1_ENDE
	BSF S0,3	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF S0,3	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 14
	SUBWF Z1,W	; F - W -> W

LABEL_IF1_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S0,6
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S0,6

LABEL_IF1_EXIT
;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW 130
	SUBWF Z1,W	; F - W -> W

LABEL_IF2_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S0,4
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S0,4

LABEL_IF2_EXIT
;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS S0,4
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S0,5
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF S0,5
	BTFSC S0,4
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; ODER - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSC S1,0
	GOTO LABEL_LG2_TRUE
LABEL_LG2_2
	BTFSC S0,7
	GOTO LABEL_LG2_TRUE

LABEL_LG2_FALSE
	BCF S0,2
	GOTO LABEL_LG2_ENDE
LABEL_LG2_TRUE
	BSF S0,2
LABEL_LG2_ENDE
;***************************************************
; One Shot -> OS2
;***************************************************


	BTFSS S0,6
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S0,7
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF S0,7
	BTFSC S0,6
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; One Shot -> OS3
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF S1,0
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF S1,0
	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,0
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************
; Vergleich -> IF3
;***************************************************

	MOVLW 130
	SUBWF Z1,W	; F - W -> W

LABEL_IF3_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF3_FALSE

LABEL_IF3_TRUE
	BSF S1,2
	GOTO LABEL_IF3_EXIT

LABEL_IF3_FALSE
	BCF S1,2

LABEL_IF3_EXIT
;***************************************************
; RS-FLIP-FLOP -> RS2
;***************************************************

	BTFSC S1,2
	GOTO LABEL_RS2_RESET
	BTFSS S1,1
	GOTO LABEL_RS2_ENDE
	BCF STATUS,RP0	; Bank 0
	BSF PORTA,1	; Ausgang setzen
	GOTO LABEL_RS2_ENDE
LABEL_RS2_RESET
	BCF STATUS,RP0	; Bank 0
	BCF PORTA,1	; Ausgang zurcksetzen
LABEL_RS2_ENDE

;***************************************************
; Vergleich -> IF4
;***************************************************

	MOVLW 129
	SUBWF Z1,W	; F - W -> W

LABEL_IF4_CHECK
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF4_FALSE

LABEL_IF4_TRUE
	BSF S1,1
	GOTO LABEL_IF4_EXIT

LABEL_IF4_FALSE
	BCF S1,1

LABEL_IF4_EXIT
;****************************************

	GOTO MAIN

	ORG 491
;***************************************************
; Table -> TAB
;***************************************************

TAB

	MOVWF SYS_TMP1
	MOVLW HIGH TAB_WERTE
	MOVWF PCLATH
	MOVFW SYS_TMP1
	BCF INTCON,GIE
	ADDWF PCL,F

TAB_WERTE

	RETLW 129	; // INDEX 0
	RETLW 33	; // INDEX 1
	RETLW 10	; // INDEX 2
	RETLW 65	; // INDEX 3
	RETLW 17	; // INDEX 4
	RETLW 10	; // INDEX 5
	RETLW 18	; // INDEX 6
	RETLW 18	; // INDEX 7
	RETLW 20	; // INDEX 8
	RETLW 12	; // INDEX 9
	RETLW 33	; // INDEX 10
	RETLW 130	; // INDEX 11
	RETLW 0	; // INDEX 12
	RETLW 0	; // INDEX 13
	RETLW 0	; // INDEX 14


	END

